/*======================================================================*/
/* Bstr.cpp: CBSTR wrapper class - because CComBSTR is buggy			*/
/* Copyright 2001-2003, (C) Jean-Pierre Menicucci - all rights reserved	*/
/*======================================================================*/
/* when calling CComBSTR::CComBSTR (n, lp), the constructor converts lp */
/* to OLECHAR without using the length parameter, but only the ending	*/
/* null character, thus causing a stack overflow when lp is big			*/
/*======================================================================*/

#include "XmlWord.h"
#include "Bstr.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CBSTR::CBSTR ()
{
	m_bs = 0;
}

CBSTR::CBSTR (LPSTR lp)
{
	int n = lstrlen (lp);

	m_bs = SysAllocStringLen ((OLECHAR FAR *) 0, n);

	if (m_bs)
		MultiByteToWideChar (CP_ACP, 0, lp, n, m_bs, n);
}

CBSTR::CBSTR (int n, LPSTR lp)
{
	m_bs = SysAllocStringLen ((OLECHAR FAR *) 0, n);

	if (m_bs)
		MultiByteToWideChar (CP_ACP, 0, lp, n, m_bs, n);
}

CBSTR::~CBSTR()
{
	if (m_bs)
		SysFreeString (m_bs);
}
