/*======================================================================*/
/* Excel.h: CExcel Excel automation object								*/
/* Copyright 2001-2003, (C) Jean-Pierre Menicucci - all rights reserved	*/
/*======================================================================*/

#ifndef __Excel_H_
#define __Excel_H_

/////////////////////////////////////////////////////////////////////////////
// CExcel

class CExcel {

private:
	int m_nVersion;						// version number
	IDispatch *m_pDispApp;				// pointer to application

public:
	int GetVersion (void) {
		return m_nVersion;				// return excel version
		}

public:
	HRESULT Close (void);				// close CExcel
	HRESULT CreateChart (				// create chart
		LPSTR lpTit, int nTitLen,			// graph title
		LPSTR lpXax, int nXaxLen,			// X axis title
		LPSTR lpYax, int nYaxLen,			// Y axis title
		LPSTR lpDa2, int nDa2Len,			// graph data
		LPSTR lpYmi, int nYmiLen,			// Y axis min
		LPSTR lpYmx, int nYmxLen,			// Y axis max
		int nChartType						// chart type
		);
	HRESULT DeleteChart (void);			// delete chart
	HRESULT FillSheet (					// fill sheet
		LPSTR lpsDat, int nDatLen,			// data
		int* pnRow,							// row#
		int* pnCol							// col#
		);
	HRESULT Open (void);				// open Excel instance

private:
	HRESULT SeriesColor (				// set up series color
		VARIANT sc,							// series collection
		int si,								// series index
		int ci								// color index
		);
};

#endif //__Excel_H_
