/*======================================================================*/
/* Word.h: CWord Word automation object									*/
/* Copyright 2001-2003, (C) Jean-Pierre Menicucci - all rights reserved	*/
/*======================================================================*/

#ifndef __Word_H_
#define __Word_H_

/////////////////////////////////////////////////////////////////////////////
// CWord

class CWord {

private:
	int m_nVersion;						// version number
	IDispatch *m_pDispApp;				// pointer to application
	BOOL m_bPageBreak;					// last action was a page break

public:

	CWord() {
		m_bPageBreak = FALSE;			// initialize page setup
		}

	int GetVersion (void) {
		return m_nVersion;				// return word version
		}

public:
	HRESULT Add (LPSTR lpsz);			// add document from template
	HRESULT Close (void);				// close Word instance
	HRESULT CloseDocument (LPSTR lpsz);	// close document in running Word instance
	HRESULT GotoEnd();					// goto end of documents
	HRESULT FieldsUpdate (void);		// update fields
	HRESULT Image (LPSTR lpsz);			// insert image
	HRESULT LineBreak();				// type line break
	HRESULT Normal (LPSTR lp, int n);	// type text in normal style
	HRESULT Open (void);				// open Word instance
	HRESULT PageBreak();				// type page break
	HRESULT PageView (void);			// view page
	HRESULT PageTitle (					// type page title text
		int nStyle,							// title style
		LPSTR lp,							// text
		int n								// length
		);
	HRESULT Paste (float fSiz);			// graph size
	HRESULT Replace (					// replace all
		LPSTR lpszIn,						// string to replace
		LPSTR lpszOut						// replacing string
		);
	HRESULT Save (void);				// save document
	HRESULT SaveAs (LPSTR lpszPath);	// save document
	HRESULT SeekView (int nView);		// seek view
	HRESULT Table (						// setup table
		LPSTR lpsSiz, int nSizLen,			// Table size
		LPSTR lpsWid, int nWidLen,			// Column widthes
		LPSTR lpsAli, int nAliLen,			// Column alignments
		LPSTR lpsDat, int nDatLen			// Table data
		);
	HRESULT Title (						// type title text
		int nStyle,							// title style
		LPSTR lp,							// text
		int n								// length
		);
	HRESULT Zoom (int nZoom);			// page zoom percentage

private:
	HRESULT TypeCell (					// type text in cell
		IDispatch *ps,						// selection
		LPSTR lp,							// text
		int n								// length
		);
	HRESULT TypeFragments (				// type fragments in different formats
		IDispatch* ps,						// selection
		LPSTR lp,							// string
		int n								// length
		);
};

#endif //__Word_H_
