/*======================================================================*/
/* Xml.h: CXml parsing object											*/
/* Copyright 2001-2003, (C) Jean-Pierre Menicucci - all rights reserved	*/
/*======================================================================*/

#ifndef __Xml_H_
#define __Xml_H_

/////////////////////////////////////////////////////////////////////////////
// CXml

class CXml {

private:
	LPSTR m_lpsz;						// string to parse
	int m_nLen;							// string length
	int m_nOff;							// current offset

public:
	CXml::CXml() {						// default constructor
		m_lpsz = 0;
		m_nLen = 0;
		m_nOff = 0;
		}

	CXml::CXml (LPSTR lpsz, int nLen) {	// real constructor
		m_lpsz = lpsz;
		m_nLen = nLen;
		m_nOff = 0;
		}

public:
	void Accents (void);
	void Entities (void);
	int Parse (
		int* pnTagOff,					// tag offset
		int* pnTagLen,					// tag length
		int* pnDatOff,					// data offset
		int* pnDatLen,					// data length
		int* pnAttOff = 0,				// attribute offset
		int* pnAttLen = 0				// attribute length
		);
};

#endif //__Xml_H_
