// XmlWord.cpp : Implementation of DLL Exports.

// Note: Proxy/Stub Information
//		To build a separate proxy/stub DLL, 
//		run nmake -f XmlWordps.mk in the project directory.

#include "stdafx.h"						// base includes
#include "resource.h"					// resource includes
#include "Lang.h"						// CLang multilingual class
#include "Down.h"						// CDown downloading dialog class
#include "XmlWord.h"					// automation server
#include "XmlWord_i.c"					// guids definitions
#include "XmlWordAx.h"					// XmlWord ActiveX object

CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
	OBJECT_ENTRY(CLSID_XmlWordAx, CXmlWordAx)
END_OBJECT_MAP()

/////////////////////////////////////////////////////////////////////////////
// DLL Entry Point

extern "C"
BOOL WINAPI DllMain (HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		_Module.Init (ObjectMap, hInstance);
		DisableThreadLibraryCalls (hInstance);

		CLang::SetInstance (hInstance);
		CLang::SetLangId ((WORD) GetThreadLocale());

		TCHAR szLang[3];
		int nLang = CLang::LoadString (IDS_LANG, szLang, sizeof (szLang));
		if (nLang == 0) CLang::SetLangId (0x0409);
	}
	else
		if (dwReason == DLL_PROCESS_DETACH)
			_Module.Term();

	return TRUE;    // ok
}

/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

STDAPI DllCanUnloadNow(void)
{
	return (_Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
	return _Module.GetClassObject (rclsid, riid, ppv);
}

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry

STDAPI DllRegisterServer(void)
{
	// registers object, typelib and all interfaces in typelib
	return _Module.RegisterServer (TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
	_Module.UnregisterServer();
	return S_OK;
}
